#include "mcc_generated_files/mcc.h"

#define INT_MAX 300
#define INT_PB5_MAX 200
#define TIME_OFF -1
#define TIME_UP 0

int16_t timintpb5 = TIME_OFF;
int16_t timint = TIME_OFF;

void Int_CallBack(void);
void PB5Int_CallBack(void);
void mainTimer(void);
void mainApp(void);

/* Main application  */
void main(void)
{
    SYSTEM_Initialize();
    INTERRUPT_GlobalInterruptEnable();
    INTERRUPT_PeripheralInterruptEnable();
    TMR0_SetInterruptHandler(mainTimer);
    INT_SetInterruptHandler(Int_CallBack);
    IOCBF5_SetInterruptHandler(PB5Int_CallBack);
    
    while (1)
    {
        mainApp();
    }
}
/* C */
void mainApp(void){
    
    if( timintpb5 == TIME_UP){
        timintpb5 = INT_PB5_MAX;
        IO_RA3_SetLow();
    }
    
    if( timint == TIME_UP ){
        timint = TIME_OFF;
        IO_RB4_SetLow(); 
    }
}

/* EXT_INT̊荞݃R[obN */
void Int_CallBack(void){
    
    timint = INT_MAX;
    IO_RB4_SetHigh(); 
}

/* IOCI(PB5)̊荞݃R[obN */
void PB5Int_CallBack(void){
    
    timintpb5 = INT_PB5_MAX;
    IO_RA3_SetHigh(); 
}

/* ^C}Ǘ */
void mainTimer(void){
    
    if( timintpb5 > TIME_UP ){
        --timintpb5;
    }
    
    if( timint > TIME_UP ){
        --timint;
    }
}

/* End of File */